//
//  EmoticansView.m
//  EmojiKeyboardSample
//
//  Created by Meenakshi on 11/11/13.
//  Copyright (c) 2013 Mindfire Solutions. All rights reserved.
//

#import "EmoticansConstant.h"
#import "EmoticansView.h"

@implementation EmoticansView

@synthesize delegate;

- (id)initWithFrame:(CGRect)frame startIndex:(NSUInteger)startIndex endIndex:(NSUInteger)endIndex
{
    self = [super initWithFrame:frame];
    if (self)
	{
        // Initialization code
		
	}
    return self;
}

- (void) loadEmoticansFromIndex:(NSUInteger)startIndex toIndex:(NSUInteger)endIndex
{
	CGFloat x = 10, y = 0, width = 40, height = 40;
	CGFloat xOffset = 5, yOffset = 0;
	_emoticansCharacter = [EmoticansConstant emoticonsCharacters];
	if(endIndex >= _emoticansCharacter.count)
		endIndex = _emoticansCharacter.count;
	
	NSUInteger index = startIndex;
	for (int i = 0; i < kEmojiKeyboardRow; ++i)
	{
		for (int j = 0; j < kEmojiKeyboardColumn; ++j)
		{
			UIButton* btn = [UIButton buttonWithType:UIButtonTypeCustom];
			if (index >= endIndex +1)
				return;
			if (index != endIndex)
			{
				NSString* emoji = [_emoticansCharacter objectAtIndex:index];
				[btn setTitle:emoji forState:UIControlStateNormal];
				btn.tag = index;
				[btn addTarget:self action:@selector(emoticansButtonPressed:) forControlEvents:UIControlEventTouchUpInside];
			}
			else
			{
				[btn setImage:[UIImage imageNamed:@"backspace"] forState:UIControlStateNormal];
				[btn addTarget:self action:@selector(cancelButtonPressed:) forControlEvents:UIControlEventTouchUpInside];
			}

			btn.frame = CGRectMake(x, y, width, height);
			x = x + width + xOffset;
			index = index +1;
			
			[self addSubview:btn];
		}
		x = 10;
		y = y + height + yOffset;
	}
}

- (void) cleanEmoticanView
{
	for (UIButton* btn in self.subviews)
	{
		[btn removeFromSuperview];
	}
}

- (void) emoticansButtonPressed:(UIButton*)sender
{
	NSString* emotican = [_emoticansCharacter objectAtIndex:sender.tag];
	NSLog(@"%d %@", sender.tag, emotican);
	if ([self.delegate respondsToSelector:@selector(selctedEmoticanCharacter:)])
		[self.delegate selctedEmoticanCharacter:emotican];
}

- (void) cancelButtonPressed:(UIButton*)sender
{
	if ([self.delegate respondsToSelector:@selector(deleteEmoticanCharacter)])
		[self.delegate deleteEmoticanCharacter];
}

@end
