//
//  GalleryView.h
//  EmojiKeyboardSample
//
//  Created by Meenakshi on 11/11/13.
//  Copyright (c) 2013 Mindfire Solutions. All rights reserved.
//

#import "EmoticansView.h"

@protocol GalleryViewDelegate <NSObject,EmoticansViewDelegate>

@optional

- (void) selectedPageView:(EmoticansView*) page forButtonIndex:(NSInteger)index;
- (void) deleteEmoticanCharacter;

@end

@interface GalleryView : UIScrollView<UIScrollViewDelegate,EmoticansViewDelegate>
{
    NSInteger              _imageCount;
	UIPageControl*			_pageControl;

    CGSize                 _viewSize;

    NSMutableSet*          _recycledPages;
    NSMutableSet*          _visiblePages;

    NSMutableArray*         _imageArray;

    EmoticansView* _visiblePageView;
}

@property (nonatomic, retain)  NSMutableArray*  imageArray;
@property (nonatomic, retain) UIPageControl* pageControl;

@property (nonatomic, assign) id <GalleryViewDelegate>  galleryViewDelegate;

- (void) initialSetUpForScrollViewWithNeededFrames:(NSInteger) noOfFrames;
- (void) loadPages;

@end
