//
//  ViewController.m
//  EmojiKeyboardSample
//
//  Created by Meenakshi on 11/11/13.
//  Copyright (c) 2013 Mindfire Solutions. All rights reserved.
//

#import "EmoticansConstant.h"
#import "ViewController.h"


@interface ViewController ()
{
	BOOL _emoticanKeyboardFlag;
}

@end

@implementation ViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


#pragma mark-
#pragma mark - Emoticans Gallery view

- (void) initilaizeAndDisplayGalleryView
{
	_emoticanKeyboardFlag = YES;
	
	if (_keyboardView == nil)
		_keyboardView = [[UIView alloc] initWithFrame:CGRectMake(0, self.view.frame.size.height - kEmojiKeyboardHeight -20, self.view.frame.size.height, kEmojiKeyboardHeight+20)];
	_keyboardView.backgroundColor = [UIColor grayColor];
	
	UIPageControl* pageControl = [[UIPageControl alloc] initWithFrame:CGRectMake(0, _keyboardView.frame.size.height -20, _keyboardView.frame.size.width, 20)];
//	[pageControl addTarget:self action:@selector(changePage:) forControlEvents:UIControlEventValueChanged];

	[_keyboardView addSubview:pageControl];
	
 	if (_galleryView == nil)
		_galleryView = [[GalleryView alloc] initWithFrame:CGRectZero];
	CGRect frame = CGRectMake(0, 0, self.view.frame.size.width, kEmojiKeyboardHeight);
	_galleryView.pageControl = pageControl;
	_galleryView.frame = frame;
	_galleryView.galleryViewDelegate = self;
	_galleryView.backgroundColor = [UIColor whiteColor];
	
	NSUInteger noOfEmoticansCharacter = [[EmoticansConstant emoticonsCharacters] count];
	NSUInteger noOfFrames = noOfEmoticansCharacter/(kEmojiKeyboardColumn*kEmojiKeyboardRow - 1);
	
	[_galleryView initialSetUpForScrollViewWithNeededFrames:noOfFrames+1];
	[_keyboardView addSubview:_galleryView];
	_textField.inputView = _keyboardView;

}

- (void) hideGalleryView
{
	[_textField resignFirstResponder];
}

#pragma mark- HDMEmoticansViewDelegate method

- (void)selctedEmoticanCharacter:(NSString*)emotican
{
	NSString* replacementText =[_textField.text stringByAppendingString:emotican];
	_textField.text = replacementText;
}

- (void) deleteEmoticanCharacter
{
	NSString* str = _textField.text;
	
	if ([str length] > 0)
	{
		NSString* truncatedString = [str substringToIndex:[str length]-1];
		_textField.text = truncatedString;
	}
}

#pragma mark-

- (BOOL)textFieldShouldBeginEditing:(UITextField *)textField
{
	if (!_emoticanKeyboardFlag)
		[self initilaizeAndDisplayGalleryView];
	return YES;
}

- (BOOL)textFieldShouldReturn:(UITextField *)textField
{
	if (_emoticanKeyboardFlag)
		[self hideGalleryView];
	
	return YES;
}

#pragma mark-

-(void) touchesBegan: (NSSet *) touches withEvent: (UIEvent *) event
{
	if ([_textField isFirstResponder])
		[_textField resignFirstResponder];
}

//#pragma mark-
//
//- (IBAction)changePage:(id)sender
//{
//	[_galleryView loadPages];
//}

@end
